﻿@model IEnumerable<Case_Professional.Models.Organisation>

@{
    ViewBag.Title = "Index";
}

<h2>Organisations</h2>

<p>
    @Html.ActionLink("Create New", "Create")
</p>

@{
    if (Model != null && Model.Any())
    {
        <table class="table table-responsive">
            <tr>
                <th>
                    @Html.DisplayNameFor(model => model.Name)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.LicenseKey)
                </th>
                <th>
                    @Html.DisplayNameFor(model => model.AddedOn)
                </th>
                <th></th>
            </tr>
            @foreach (var organisation in Model)
            {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => organisation.Name)
                </td>
                <td>
                    @{
                        if (organisation.LicenseKey==null)
                        {
                            <a href="#" 
                               class="btn btn-default"
                               onclick="@String.Format("fetchGeneratedOrganisationKey(this, '{0}')", organisation.Id)">Generate Key</a>
                        }
                        else
                        {
                            @Html.DisplayFor(modelItem => organisation.LicenseKey)
                        }
                    }
                </td>
                <td>
                    @Html.DisplayFor(modelItem => organisation.AddedOn)
                </td>
                <td>
                    @Html.ActionLink("Edit", "Edit", new {id = organisation.Id}) |
                    @Html.ActionLink("Details", "Details", new {id = organisation.Id}) |
                    @Html.ActionLink("Delete", "Delete", new {id = organisation.Id})
                </td>
            </tr>
            }
        </table>
    }
    else
    {
        <tr><td>No organisations added</td></tr>
    }
}

@section scripts
{
    <script>
        function fetchGeneratedOrganisationKey(element, organisationId) {
            element.innerHTML = "Generating...";
            $.post('@Url.Action("ResetLicenseKey")', { id: organisationId })
                .done(function(response) {
                    setTimeout(function() {
                        $(element).parent().append(response);
                        $(element).remove();
                    }, 1500);
            });
        }
    </script>
}
